﻿using AsReaderP252BiOSSDK;
using AsReaderP252BSDK;
using Foundation;

namespace AsReaderP252BiOSDemo.Platforms.iOS
{
	public class AsReaderP252BSDelegate
    { 
        public delegate void WhenAsReaderP252BIsConnectedDelegate(bool isConnected);
        public WhenAsReaderP252BIsConnectedDelegate WhenAsReaderP252BIsConnected;

        public delegate void ReadAsReaderP252BTagDelegate(string tag, float rssi, float phase, float frequency);
        public ReadAsReaderP252BTagDelegate ReadAsReaderP252BTag;

        public delegate void DetectBarcodeDelegate(string barcodeType, NSData barcodeData);
        public DetectBarcodeDelegate DetectBarcode;

        public delegate bool OnAsReaderP252BTriggerKeyEventDelegate(bool status);
        public OnAsReaderP252BTriggerKeyEventDelegate OnAsReaderP252BTriggerKeyEvent;
         
        public delegate void ChangedAsReaderP252BActionStateDelegate(AsReaderP252BCommandType action, nint resultCode);
        public ChangedAsReaderP252BActionStateDelegate ChangedAsReaderP252BActionState;

        public delegate void DidDiscoverAsReaderP252BDeviceListDelegate(List<AsReaderP252B> list);
        public DidDiscoverAsReaderP252BDeviceListDelegate DidDiscoverAsReaderP252BDeviceList;

        static AsReaderP252BSDelegate uniqueInstance;

        static readonly object locker = new object();

        public static AsReaderP252BSDelegate sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderP252BSDelegate();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReaderP252BSDelegate()
        {
        }
    }
}

